using System;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;

namespace UnifiedPOS.CoinAcceptor.V1_4
{
    [ServiceContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public interface CoinAcceptor
    {
        #region Version 1.1

        //
        // Common Properties
        //

//        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetAutoDisable", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetAutoDisableResponse")]
//        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
//        bool GetAutoDisable(string ConsumerID);

//        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/SetAutoDisable", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/SetAutoDisableResponse")]
//        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
//        void SetAutoDisable(string ConsumerID, bool AutoDisable);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetCapCompareFirmwareVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetCapCompareFirmwareVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        bool GetCapCompareFirmwareVersion(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetCapPowerReporting", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetCapPowerReportingResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        PowerReporting GetCapPowerReporting(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetCapStatisticsReporting", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetCapStatisticsReportingResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        bool GetCapStatisticsReporting(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetCapUpdateFirmware", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetCapUpdateFirmwareResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        bool GetCapUpdateFirmware(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetCapUpdateStatistics", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetCapUpdateStatisticsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        bool GetCapUpdateStatistics(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetCheckHealthText", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetCheckHealthTextResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        string GetCheckHealthText(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetClaimed", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetClaimedResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        bool GetClaimed(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetDataCount", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetDataCountResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        int GetDataCount(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetDataEventEnabled", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetDataEventEnabledResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        bool GetDataEventEnabled(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/SetDataEventEnabled", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/SetDataEventEnabledResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        void SetDataEventEnabled(string ConsumerID, bool DataEventEnabled);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetDeviceEnabled", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetDeviceEnabledResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        bool GetDeviceEnabled(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/SetDeviceEnabled", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/SetDeviceEnabledResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        void SetDeviceEnabled(string ConsumerID, bool DeviceEnabled);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetFreezeEvents", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetFreezeEventsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        bool GetFreezeEvents(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/SetFreezeEvents", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/SetFreezeEventsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        void SetFreezeEvents(string ConsumerID, bool FreezeEvents);

//        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetOutputID", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetOutputIDResponse")]
//        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
//        int GetOutputID(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetPowerNotify", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetPowerNotifyResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        PowerNotification GetPowerNotify(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/SetPowerNotify", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/SetPowerNotifyResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        void SetPowerNotify(string ConsumerID, PowerNotification PowerNotify);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetPowerState", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetPowerStateResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        PowerState GetPowerState(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetState", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetStateResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        ControlState GetState(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetDeviceControlDescription", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetDeviceControlDescriptionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        string GetDeviceControlDescription(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetDeviceControlVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetDeviceControlVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        UposVersion GetDeviceControlVersion(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetDeviceServiceDescription", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetDeviceServiceDescriptionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        string GetDeviceServiceDescription(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetDeviceServiceVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetDeviceServiceVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        UposVersion GetDeviceServiceVersion(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetPhysicalDeviceDescription", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetPhysicalDeviceDescriptionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        string GetPhysicalDeviceDescription(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetPhysicalDeviceName", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetPhysicalDeviceNameResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        string GetPhysicalDeviceName(string ConsumerID);

        //
        // Specific Properties
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetCapDiscrepancy", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetCapDiscrepancyResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        bool GetCapDiscrepancy(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetCapFullSensor", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetCapFullSensorResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        bool GetCapFullSensor(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetCapJamSensor", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetCapJamSensorResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        bool GetCapJamSensor(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetCapNearFullSensor", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetCapNearFullSensorResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        bool GetCapNearFullSensor(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetCapPauseDeposit", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetCapPauseDepositResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        bool GetCapPauseDeposit(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetCapRealTimeData", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetCapRealTimeDataResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        bool GetCapRealTimeData(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetCurrencyCode", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetCurrencyCodeResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        string GetCurrencyCode(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/SetCurrencyCode", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/SetCurrencyCodeResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        void SetCurrencyCode(string ConsumerID, string CurrencyCode);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetDepositAmount", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetDepositAmountResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        int GetDepositAmount(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetDepositCashList", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetDepositCashListResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        CashUnits GetDepositCashList(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetDepositCodeList", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetDepositCodeListResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
//        string[] GetDepositCodeList();
        DepositCodeList GetDepositCodeList(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetDepositCounts", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetDepositCountsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
//        CashCount[] GetDepositCounts();
        CashCountList GetDepositCounts(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetDepositStatus", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetDepositStatusResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        DepositStatus GetDepositStatus(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetFullStatus", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetFullStatusResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        CashChangerFullStatus GetFullStatus(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetRealTimeDataEnabled", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetRealTimeDataEnabledResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        bool GetRealTimeDataEnabled(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/SetRealTimeDataEnabled", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/SetRealTimeDataEnabledResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        void SetRealTimeDataEnabled(string ConsumerID, bool RealTimeDataEnabled);

        //
        // Common Methods
        //

        //[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/Open", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/OpenResponse")]
        //[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        //void Open(string ConsumerID, string EndpointAddress);

        //[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/Close", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/CloseResponse")]
        //[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        //void Close(string ConsumerID, string EndpointAddress);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/Claim", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/ClaimResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        void Claim(string ConsumerID, int Timeout);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/Release", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/ReleaseResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        void Release(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/CheckHealth", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/CheckHealthResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        void CheckHealth(string ConsumerID, HealthCheckLevel Level);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/ClearInput", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/ClearInputResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        void ClearInput(string ConsumerID);

//        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/ClearInputProperties", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/ClearInputPropertiesResponse")]
//        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
//        void ClearInputProperties(string ConsumerID);

//        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/ClearOutput", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/ClearOutputResponse")]
//        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
//        void ClearOutput(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/DirectIO", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/DirectIOResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        DirectIOData DirectIO(string ConsumerID, int Command, int Data, object Obj);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/CompareFirmwareVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/CompareFirmwareVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        CompareFirmwareResult CompareFirmwareVersion(string ConsumerID, string FirmwareFileName);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/ResetStatistics", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/ResetStatisticsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        void ResetStatistics(string ConsumerID, StatisticList StatisticsBuffer);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/RetrieveStatistics", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/RetrieveStatisticsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        string RetrieveStatistics(string ConsumerID, StatisticList StatisticsBuffer);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UpdateFirmware", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UpdateFirmwareResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        void UpdateFirmware(string ConsumerID, string FirmwareFileName);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UpdateStatistics", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UpdateStatisticsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        void UpdateStatistics(string ConsumerID, StatisticList StatisticsBuffer);

        //
        // Specific Methods
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/AdjustCashCounts", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/AdjustCashCountsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
//        void AdjustCashCounts(IEnumerable<CashCount> cashCounts);
        void AdjustCashCounts(string ConsumerID, CashCountList CashCounts);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/BeginDeposit", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/BeginDepositResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        void BeginDeposit(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/EndDeposit", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/EndDepositResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        void EndDeposit(string ConsumerID, EndDepositAction Success);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/FixDeposit", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/FixDepositResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        void FixDeposit(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/PauseDeposit", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/PauseDepositResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        void PauseDeposit(string ConsumerID, CashDepositPause Control);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/ReadCashCounts", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/ReadCashCountsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        CashCounts ReadCashCounts(string ConsumerID);

        #endregion

        #region Version 1.2

        //
        // Session Management
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetWSPOSVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetWSPOSVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        UposVersion GetWSPOSVersion();

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GenerateConsumerID", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GenerateConsumerIDResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        string GenerateConsumerID();

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/OpenSession", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/OpenSessionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        void OpenSession(string ConsumerID, string EndpointAddress);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/CloseSession", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/CloseSessionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        void CloseSession(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetProviderSessionTimeout", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetProviderSessionTimeoutResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        int GetProviderSessionTimeout(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/KeepAlive", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/KeepAliveResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        void KeepAlive(string ConsumerID);

        //
        // Device Control
        // 

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/OpenDevice", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/OpenDeviceResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        void OpenDevice(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/CloseDevice", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/CloseDeviceResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        void CloseDevice(string ConsumerID);

        //
        // Event Polling
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/PollForUPOSEvent", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/PollForUPOSEventResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        CoinAcceptorEvent PollForUPOSEvent(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/SetEventResponse", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/SetEventResponseResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        void SetEventResponse(string ConsumerID, CoinAcceptorEventResponse EventResponse);

        #endregion

        #region Version 1.3

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetEncryptedClaimedConsumerID", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/GetEncryptedClaimedConsumerIDResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        string GetEncryptedClaimedConsumerID();

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/SetEventRequestProperties", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/SetEventRequestPropertiesResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/UposException", Name = "UposException")]
        void SetEventRequestProperties(string ConsumerID, PropertyNameList list);

        #endregion

    }

    #region Version 1.1

    //
    // Common Data Types
    //

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public class DirectIOData
    {
        [DataMember]
        public int Data { get; set; }
        [DataMember]
        public object Obj { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public class UposException
    {
        [DataMember]
        public ErrorCode ErrorCode { get; set; }
        [DataMember]
        public int ErrorCodeExtended { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public class UposVersion
    {
        [DataMember]
        public int Major { get; set; }
        [DataMember]
        public int Minor { get; set; }
        [DataMember]
        public int Build { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public class Statistic
    {
        [DataMember]
        public string Name { get; set; }
        [DataMember]
        public string Value { get; set; }
    }

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/", ItemName = "Statistic")]
    public class StatisticList : List<Statistic>
    {
    }

    //
    // Common Enumerations
    //

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public enum CompareFirmwareResult
    {
        [EnumMember]
        CFV_FIRMWARE_OLDER,
        [EnumMember]
        CFV_FIRMWARE_SAME,
        [EnumMember]
        CFV_FIRMWARE_NEWER,
        [EnumMember]
        CFV_FIRMWARE_DIFFERENT,
        [EnumMember]
        CFV_FIRMWARE_UNKNOWN,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public enum ControlState
    {
        [EnumMember]
        S_CLOSED,
        [EnumMember]
        S_IDLE,
        [EnumMember]
        S_BUSY,
        [EnumMember]
        S_ERROR,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public enum ErrorCode
    {
        [EnumMember]
        E_CLOSED,
        [EnumMember]
        E_CLAIMED,
        [EnumMember]
        E_NOTCLAIMED,
        [EnumMember]
        E_NOSERVICE,
        [EnumMember]
        E_DISABLED,
        [EnumMember]
        E_ILLEGAL,
        [EnumMember]
        E_NOHARDWARE,
        [EnumMember]
        E_OFFLINE,
        [EnumMember]
        E_NOEXIST,
        [EnumMember]
        E_EXISTS,
        [EnumMember]
        E_FAILURE,
        [EnumMember]
        E_TIMEOUT,
        [EnumMember]
        E_BUSY,
        [EnumMember]
        E_EXTENDED,
        [EnumMember]
        E_DEPRECATED,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public enum HealthCheckLevel
    {
        [EnumMember]
        CH_INTERNAL,
        [EnumMember]
        CH_EXTERNAL,
        [EnumMember]
        CH_INTERACTIVE,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public enum PowerNotification
    {
        [EnumMember]
        PN_DISABLED,
        [EnumMember]
        PN_ENABLED,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public enum PowerReporting
    {
        [EnumMember]
        PR_NONE,
        [EnumMember]
        PR_STANDARD,
        [EnumMember]
        PR_ADVANCED,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public enum PowerState
    {
        [EnumMember]
        PS_UNKNOWN,
        [EnumMember]
        PS_ONLINE,
        [EnumMember]
        PS_OFF,
        [EnumMember]
        PS_OFFLINE,
        [EnumMember]
        PS_OFF_OFFLINE,
    }

    /*
    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public enum StatisticCategories
    {
        [EnumMember]
        All,
        [EnumMember]
        Manufacturer,
        [EnumMember]
        Upos,
    }
    */
    public class StatisticCategories
    {
        public const string All = "";
        public const string Manufacturer = "M_";
        public const string Upos = "U_";
    }

    //
    // Specific Data Types
    //

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/", ItemName = "Bill")]
    public class BillList : List<int>
    {
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public class CashCount
    {
        [DataMember]
        public int Count { get; set; }
        [DataMember]
        public int NominalValue { get; set; }
        [DataMember]
        public CashCountType Type { get; set; }
    }

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/", ItemName = "CashCount")]
    public class CashCountList : List<CashCount>
    {
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public class CashCounts
    {
        [DataMember]
        public CashCountList Counts { get; set; }
        [DataMember]
        public bool Discrepancy { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public class CashUnits
    {
        [DataMember]
        public BillList Bills { get; set; }
        [DataMember]
        public CoinList Coins { get; set; }
    }

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/", ItemName = "Coin")]
    public class CoinList : List<int>
    {
    }

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/", ItemName = "DepositCode")]
    public class DepositCodeList : List<string>
    {
    }

    //
    // Specific Enumerations
    //

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public enum DepositStatus
    {
        [EnumMember]
        CACC_STATUS_DEPOSIT_START,
        [EnumMember]
        CACC_STATUS_DEPOSIT_END,
        [EnumMember]
        CACC_STATUS_DEPOSIT_COUNT,
        [EnumMember]
        CACC_STATUS_DEPOSIT_JAM,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public enum EndDepositAction
    {
        [EnumMember]
        CACC_DEPOSIT_COMPLETE,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public enum CashChangerFullStatus
    {
        [EnumMember]
        CACC_STATUS_OK,
        [EnumMember]
        CACC_STATUS_FULL,
        [EnumMember]
        CACC_STATUS_NEARFULL,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public enum CashDepositPause
    {
        [EnumMember]
        CACC_DEPOSIT_PAUSE,
        [EnumMember]
        CACC_DEPOSIT_RESTART,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public enum CashCountType
    {
        [EnumMember]
        Bill,
        [EnumMember]
        Coin,
    }

    //
    // Constants
    //

    public class ExtendedError
    {
        public const int EFIRMWARE_BAD_FILE = 281;
        public const int ESTATS_ERROR = 280;
        public const int ESTATS_DEPENDENCY = 282;
    }

    public class StatisticProperties
    {
        public const string CommunicationErrorCount = "CommunicationErrorCount";
        public const string DeviceCategory = "DeviceCategory";
        public const string FirmwareRevision = "FirmwareRevision";
        public const string HoursPoweredCount = "HoursPoweredCount";
        public const string InstallationDate = "InstallationDate";
        public const string Interface = "Interface";
        public const string ManufactureDate = "ManufactureDate";
        public const string ManufacturerName = "ManufacturerName";
        public const string MechanicalRevision = "MechanicalRevision";
        public const string ModelName = "ModelName";
        public const string SerialNumber = "SerialNumber";
        public const string UnifiedPOSVersion = "UnifiedPOSVersion";
    }

    public class Wait
    {
        public const int FOREVER = -1;
    }

    #endregion

    #region Version 1.2

    //
    // Event Polling
    //

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public class CoinAcceptorEvent
    {
        [DataMember]
        public DataEvent DataEvent { get; set; }
        [DataMember]
        public DirectIOEvent DirectIOEvent { get; set; }
        //[DataMember]
        //public ErrorEvent ErrorEvent { get; set; }
        //[DataMember]
        //public OutputCompleteEvent OutputCompleteEvent { get; set; }
        [DataMember]
        public StatusUpdateEvent StatusUpdateEvent { get; set; }
        [DataMember]
        public DataContainedEvent DataContainedEvent { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public class CoinAcceptorEventResponse
    {
        [DataMember]
        public DataEventResponse DataEventResponse { get; set; }
        [DataMember]
        public DataContainedEventResponse DataContainedEventResponse { get; set; }
        [DataMember]
        public DirectIOEventResponse DirectIOEventResponse { get; set; }
        //[DataMember]
        //public ErrorEventResponse ErrorEventResponse { get; set; }
        //[DataMember]
        //public OutputCompleteEventResponse OutputCompleteEventResponse { get; set; }
        [DataMember]
        public StatusUpdateEventResponse StatusUpdateEventResponse { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public class DataEvent
    {
        [DataMember]
        public string Source { get; set; }
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DateTime TimeStamp { get; set; }
        [DataMember]
        public int Status { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public class DataEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public class DirectIOEvent
    {
        [DataMember]
        public string Source { get; set; }
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DateTime TimeStamp { get; set; }
        [DataMember]
        public int EventNumber { get; set; }
        [DataMember]
        public int Data { get; set; }
        [DataMember]
        public object Obj { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public class DirectIOEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DirectIOData DirectIOData { get; set; }
    }
    /*
    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public class ErrorEvent
    {
        [DataMember]
        public string Source { get; set; }
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DateTime TimeStamp { get; set; }
        [DataMember]
        public ErrorCode ErrorCode { get; set; }
        [DataMember]
        public int ErrorCodeExtended { get; set; }
        [DataMember]
        public ErrorLocus ErrorLocus { get; set; }
        [DataMember]
        public ErrorResponse ErrorResponse { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public class ErrorEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public ErrorResponse ErrorResponse { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public class OutputCompleteEvent
    {
        [DataMember]
        public string Source { get; set; }
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DateTime TimeStamp { get; set; }
        [DataMember]
        int OutputID { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public class OutputCompleteEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
    }
    */
    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public class StatusUpdateEvent
    {
        [DataMember]
        public string Source { get; set; }
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DateTime TimeStamp { get; set; }
        [DataMember]
        public int Status { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public class StatusUpdateEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
    }
    /*
    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public enum ErrorLocus
    {
        [EnumMember]
        EL_INPUT,
        [EnumMember]
        EL_INPUT_DATA,
        [EnumMember]
        EL_OUTPUT,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public enum ErrorResponse
    {
        [EnumMember]
        ER_CLEAR,
        [EnumMember]
        ER_CONTINUEINPUT,
        [EnumMember]
        ER_RETRY,
    }
    */
    #endregion

    #region Version 1.3

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/", ItemName = "PropertyName")]
    public class PropertyNameList : List<string>
    {
    }



    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/", ItemName = "Parameter")]
    public class ParameterList : Dictionary<string, object>
    {
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public class DataContainedEvent
    {
        [DataMember]
        public string Source { get; set; }
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DateTime TimeStamp { get; set; }
        [DataMember]
        public int Status { get; set; }
        [DataMember]
        public ParameterList Parameters { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public class DataContainedEventData
    {
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public bool SetDataEventEnabled { get; set; }
        [DataMember]
        public bool CallClearInputProperties { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/CoinAcceptor/")]
    public class DataContainedEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public bool SetDataEventEnabled { get; set; }
        [DataMember]
        public bool CallClearInputProperties { get; set; }
    }

    #endregion
}
